package com.duanledexianxianxian.maven.flink.common.schemas;

import com.alibaba.fastjson.JSONObject;
import org.apache.flink.api.common.typeinfo.TypeInformation;
import org.apache.flink.streaming.connectors.kafka.KafkaDeserializationSchema;
import org.apache.flink.streaming.connectors.kafka.KafkaSerializationSchema;
import org.apache.kafka.clients.consumer.ConsumerRecord;
import org.apache.kafka.clients.producer.ProducerRecord;

import javax.annotation.Nullable;

/**
 * @author Administrator
 */
public class SimplekafkaStringSchema implements KafkaSerializationSchema<Object>, KafkaDeserializationSchema<String> {
    private String topic;

    @Override
    public ProducerRecord<byte[], byte[]> serialize(Object element, @Nullable Long timestamp) {
        return new ProducerRecord(this.topic, JSONObject.toJSONString(element));
    }

    public String getTopic() {
        return topic;
    }

    public void setTopic(String topic) {
        this.topic = topic;
    }

    @Override
    public boolean isEndOfStream(String nextElement) {
        return false;
    }

    @Override
    public String deserialize(ConsumerRecord<byte[], byte[]> record) throws Exception {
        return null;
    }

    @Override
    public TypeInformation<String> getProducedType() {
        return null;
    }
}
