package com.duanledexianxianxian.maven.flink.dataset;

import org.apache.flink.api.common.functions.FlatMapFunction;
import org.apache.flink.api.common.functions.MapPartitionFunction;
import org.apache.flink.api.common.operators.Order;
import org.apache.flink.api.common.typeinfo.Types;
import org.apache.flink.api.java.DataSet;
import org.apache.flink.api.java.ExecutionEnvironment;
import org.apache.flink.api.java.tuple.Tuple2;
import org.apache.flink.util.Collector;

import java.util.stream.Collectors;

/**
 * @author Administrator
 */
public class DataSetApi {
    public static void main(String[] args) throws Exception {
        // get environment
        final ExecutionEnvironment env = ExecutionEnvironment.getExecutionEnvironment();

        DataSet<Integer> dataSet = env.fromElements(1, 2, 3, 4, 4, 5, 6);

//        DataSet<Tuple2<Integer, Integer>> result = dataSet
//                .flatMap((FlatMapFunction<Integer, Tuple2<Integer, Integer>>) (x, y) -> y.collect(new Tuple2<Integer, Integer>(x, 1))).returns(Types.TUPLE(Types.INT, Types.INT));


//        DataSet<Tuple2<Integer, Integer>> result = dataSet.mapPartition(new MyMapPartitionFunction()).returns(Types.TUPLE(Types.INT, Types.INT));

//        DataSet<Integer> result = dataSet.filter(x -> x > 5);


//        DataSet<Integer> result = dataSet.distinct();

//        // 输出25
//        DataSet<Integer> result = dataSet.reduce((x, y) -> {
//            return x + y;
//        });


        DataSet<Tuple2<Integer, Integer>> result = dataSet
                .flatMap((FlatMapFunction<Integer, Tuple2<Integer, Integer>>) (x, y) -> y.collect(new Tuple2<Integer, Integer>(x, 1))).returns(Types.TUPLE(Types.INT, Types.INT));

        // 输出(6,7)
        result.sum(1).print();

        // 输出(1,1)
        result.min(0).print();

        //输出(6,1)
        result.max(0).sum(1).print();

//        (1,1)
        result.minBy(0).print();

//        (6,1)
        result.maxBy(0).print();


//        (3,1)
//        (1,1)
//        (5,1)
//        (6,1)
//        (2,1)
//        (4,2)
        result.groupBy(0).sum(1).print();

        result.groupBy(0).sortGroup(0, Order.ASCENDING).first(2).print();

//        env.execute();
    }

    public static class MyMapPartitionFunction implements MapPartitionFunction<Integer, Tuple2<Integer, Integer>> {

        @Override
        public void mapPartition(Iterable<Integer> values, Collector<Tuple2<Integer, Integer>> out) throws Exception {
            values.forEach(x -> {
                out.collect(new Tuple2<>(x, 1));
            });
        }
    }

}
